explain_ungetc_or_die(3)

NAME
explain_ungetc_or_die - push a character back to a stream and report errors
    "push a character back to a stream and report errors"

SYNOPSIS
#include <libexplain/ungetc.h>

void explain_ungetc_or_die(int c, FILE *fp);
int explain_ungetc_on_error(int c, FILE *fp);

DESCRIPTION
The explain_ungetc_or_die function is used to call the ungetc(3) system call. On failure an explanation will be printed to stderr, obtained from the explain_ungetc(3) function, and then the process terminates by calling exit(EXIT_FAILURE).

The explain_ungetc_on_error function is used to call the ungetc(3) system call. On failure an explanation will be printed to stderr, obtained from the explain_ungetc(3) function, but still returns to the caller.

c   The c, exactly as to be passed to the ungetc(3) system call.

fp  The fp, exactly as to be passed to the ungetc(3) system call.

RETURN VALUE
The explain_ungetc_or_die function only returns on success, see ungetc(3) for more information. On failure, prints an explanation and exits, it does not return.

The explain_ungetc_on_error function always returns the value return by the wrapped ungetc(3) system call.

EXAMPLE
The explain_ungetc_or_die function is intended to be used in a fashion similar to the following example:
    explain_ungetc_or_die(c, fp);

SEE ALSO

ungetc(3)
    push a character back to a stream

explain_ungetc(3)
    explain ungetc(3) errors

exit(2)
    terminate the calling process

COPYRIGHT
libexplain version 1.4
Copyright (C) 2010 Peter Miller